/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.VersionDto;
import com.portofolio.service.VersionSystemService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/version")
public class VersionController extends LocaleController {
	@Lazy
	@Autowired
	private VersionSystemService versionSystemService;
	
	@ApiOperation("Api Untuk Menyimpan Version")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody VersionDto dto, HttpServletRequest request) {
		Map<String, Object> result = versionSystemService.save(dto);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan Semua Version")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> find(
			@RequestParam(value = "dir", defaultValue = "namaVersion") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaVersion", required = false, defaultValue = "") String namaVersion) {
		Map<String, Object> result = versionSystemService.grid(sort, dir, namaVersion);
		
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan Semua Version")
	@GetMapping("/combo")
	public ResponseEntity<Map<String, Object>> combo(
			@RequestParam(value = "dir", defaultValue = "namaVersion") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaVersion", required = false, defaultValue = "") String namaVersion) {
		Map<String, Object> result = versionSystemService.combo(sort, dir, namaVersion);
		
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan Version")
	@GetMapping("/findByKdVersion")
	public ResponseEntity<Map<String, Object>> findByKdVersion(
			@RequestParam(value = "kdVersion", required = true)Integer kdVersion,
			@RequestParam(value = "isHierarki", required = true) boolean isHierarki
			) {
		Map<String, Object> result = versionSystemService.findByKdVersionSystem(kdVersion, isHierarki);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Update Version")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdVersion", required = true) Integer kdVersion,
			@RequestParam(value = "version", required = true) Integer version, 
			@Valid @RequestBody VersionDto entity,
			HttpServletRequest request) {
		Map<String, Object> result = versionSystemService.update(entity,kdVersion,version);
		
		return RestUtil.getJsonResponse(result);
	}
	
	
	
	@ApiOperation("Api Untuk Delete Version")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> delete(
			@RequestParam(value = "kdVersion", required = true) Integer kdVersion,
			@RequestParam(value = "version", required = true) Integer version,
			HttpServletRequest request) {
		Map<String, Object> result = versionSystemService.delete(kdVersion, version);
		
		return RestUtil.getJsonResponse(result);
	}
	
	
	
	

}
